﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class addFakeFksToOtherSidesStep2 : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_CustomProjectTests_TestCaseSettingses_TestSettingsId",
                table: "CustomProjectTests");

            migrationBuilder.DropForeignKey(
                name: "FK_Solutions_SolutionAssessment_AssessmentId",
                table: "Solutions");

            migrationBuilder.DropForeignKey(
                name: "FK_Tests_TestCaseSettingses_TestSettingsId",
                table: "Tests");

            migrationBuilder.DropForeignKey(
                name: "FK_GroupRoles_GroupRolePermissions_GroupRolePermissionId",
                table: "GroupRoles");

            migrationBuilder.DropForeignKey(
                name: "FK_UserSettingses_CodeEditorSettings_CodeEditorSettingsId",
                table: "UserSettingses");

            migrationBuilder.DropForeignKey(
                name: "FK_SystemRoles_SystemRolePermissions_SystemRolePermissionId",
                table: "SystemRoles");

            migrationBuilder.DropIndex(
                name: "IX_SystemRoles_SystemRolePermissionId",
                table: "SystemRoles");

            migrationBuilder.DropIndex(
                name: "IX_UserSettingses_CodeEditorSettingsId",
                table: "UserSettingses");

            migrationBuilder.DropIndex(
                name: "IX_GroupRoles_GroupRolePermissionId",
                table: "GroupRoles");

            migrationBuilder.DropIndex(
                name: "IX_Tests_TestSettingsId",
                table: "Tests");

            migrationBuilder.DropIndex(
                name: "IX_Solutions_AssessmentId",
                table: "Solutions");

            migrationBuilder.DropIndex(
                name: "IX_CustomProjectTests_TestSettingsId",
                table: "CustomProjectTests");

            migrationBuilder.DropColumn(
                name: "SystemRolePermissionId",
                table: "SystemRoles");

            migrationBuilder.DropColumn(
                name: "CodeEditorSettingsId",
                table: "UserSettingses");

            migrationBuilder.DropColumn(
                name: "GroupRolePermissionId",
                table: "GroupRoles");

            migrationBuilder.DropColumn(
                name: "TestSettingsId",
                table: "Tests");

            migrationBuilder.DropColumn(
                name: "AssessmentId",
                table: "Solutions");

            migrationBuilder.DropColumn(
                name: "TestSettingsId",
                table: "CustomProjectTests");

            migrationBuilder.AddColumn<DateTime>(
                name: "CreatedAt",
                table: "SolutionAssessment",
                nullable: false,
                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));

            migrationBuilder.AddColumn<DateTime>(
                name: "LastUpdatedAt",
                table: "SolutionAssessment",
                nullable: false,
                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));

            migrationBuilder.CreateIndex(
                name: "IX_SystemRolePermissions_SystemRoleId",
                table: "SystemRolePermissions",
                column: "SystemRoleId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CodeEditorSettings_UserSettingId",
                table: "CodeEditorSettings",
                column: "UserSettingId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_GroupRolePermissions_GroupRoleId",
                table: "GroupRolePermissions",
                column: "GroupRoleId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_TestCaseSettingses_TestId",
                table: "TestCaseSettingses",
                column: "TestId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SolutionAssessment_UserId_ExerciseReleaseId_PLangId",
                table: "SolutionAssessment",
                columns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestSettings_CustomProjectTestId",
                table: "CustomProjectTestSettings",
                column: "CustomProjectTestId",
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_CustomProjectTestSettings_CustomProjectTests_CustomProjectTestId",
                table: "CustomProjectTestSettings",
                column: "CustomProjectTestId",
                principalTable: "CustomProjectTests",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_SolutionAssessment_Solutions_UserId_ExerciseReleaseId_PLangId",
                table: "SolutionAssessment",
                columns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                principalTable: "Solutions",
                principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TestCaseSettingses_Tests_TestId",
                table: "TestCaseSettingses",
                column: "TestId",
                principalTable: "Tests",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_GroupRolePermissions_GroupRoles_GroupRoleId",
                table: "GroupRolePermissions",
                column: "GroupRoleId",
                principalTable: "GroupRoles",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_CodeEditorSettings_UserSettingses_UserSettingId",
                table: "CodeEditorSettings",
                column: "UserSettingId",
                principalTable: "UserSettingses",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_SystemRolePermissions_SystemRoles_SystemRoleId",
                table: "SystemRolePermissions",
                column: "SystemRoleId",
                principalTable: "SystemRoles",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_CustomProjectTestSettings_CustomProjectTests_CustomProjectTestId",
                table: "CustomProjectTestSettings");

            migrationBuilder.DropForeignKey(
                name: "FK_SolutionAssessment_Solutions_UserId_ExerciseReleaseId_PLangId",
                table: "SolutionAssessment");

            migrationBuilder.DropForeignKey(
                name: "FK_TestCaseSettingses_Tests_TestId",
                table: "TestCaseSettingses");

            migrationBuilder.DropForeignKey(
                name: "FK_GroupRolePermissions_GroupRoles_GroupRoleId",
                table: "GroupRolePermissions");

            migrationBuilder.DropForeignKey(
                name: "FK_CodeEditorSettings_UserSettingses_UserSettingId",
                table: "CodeEditorSettings");

            migrationBuilder.DropForeignKey(
                name: "FK_SystemRolePermissions_SystemRoles_SystemRoleId",
                table: "SystemRolePermissions");

            migrationBuilder.DropIndex(
                name: "IX_SystemRolePermissions_SystemRoleId",
                table: "SystemRolePermissions");

            migrationBuilder.DropIndex(
                name: "IX_CodeEditorSettings_UserSettingId",
                table: "CodeEditorSettings");

            migrationBuilder.DropIndex(
                name: "IX_GroupRolePermissions_GroupRoleId",
                table: "GroupRolePermissions");

            migrationBuilder.DropIndex(
                name: "IX_TestCaseSettingses_TestId",
                table: "TestCaseSettingses");

            migrationBuilder.DropIndex(
                name: "IX_SolutionAssessment_UserId_ExerciseReleaseId_PLangId",
                table: "SolutionAssessment");

            migrationBuilder.DropIndex(
                name: "IX_CustomProjectTestSettings_CustomProjectTestId",
                table: "CustomProjectTestSettings");

            migrationBuilder.DropColumn(
                name: "CreatedAt",
                table: "SolutionAssessment");

            migrationBuilder.DropColumn(
                name: "LastUpdatedAt",
                table: "SolutionAssessment");

            migrationBuilder.AddColumn<int>(
                name: "SystemRolePermissionId",
                table: "SystemRoles",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "CodeEditorSettingsId",
                table: "UserSettingses",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "GroupRolePermissionId",
                table: "GroupRoles",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TestSettingsId",
                table: "Tests",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "AssessmentId",
                table: "Solutions",
                nullable: true);

            migrationBuilder.AddColumn<int>(
                name: "TestSettingsId",
                table: "CustomProjectTests",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateIndex(
                name: "IX_SystemRoles_SystemRolePermissionId",
                table: "SystemRoles",
                column: "SystemRolePermissionId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_UserSettingses_CodeEditorSettingsId",
                table: "UserSettingses",
                column: "CodeEditorSettingsId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_GroupRoles_GroupRolePermissionId",
                table: "GroupRoles",
                column: "GroupRolePermissionId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Tests_TestSettingsId",
                table: "Tests",
                column: "TestSettingsId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_AssessmentId",
                table: "Solutions",
                column: "AssessmentId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTests_TestSettingsId",
                table: "CustomProjectTests",
                column: "TestSettingsId",
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_CustomProjectTests_TestCaseSettingses_TestSettingsId",
                table: "CustomProjectTests",
                column: "TestSettingsId",
                principalTable: "TestCaseSettingses",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Solutions_SolutionAssessment_AssessmentId",
                table: "Solutions",
                column: "AssessmentId",
                principalTable: "SolutionAssessment",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Tests_TestCaseSettingses_TestSettingsId",
                table: "Tests",
                column: "TestSettingsId",
                principalTable: "TestCaseSettingses",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_GroupRoles_GroupRolePermissions_GroupRolePermissionId",
                table: "GroupRoles",
                column: "GroupRolePermissionId",
                principalTable: "GroupRolePermissions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_UserSettingses_CodeEditorSettings_CodeEditorSettingsId",
                table: "UserSettingses",
                column: "CodeEditorSettingsId",
                principalTable: "CodeEditorSettings",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_SystemRoles_SystemRolePermissions_SystemRolePermissionId",
                table: "SystemRoles",
                column: "SystemRolePermissionId",
                principalTable: "SystemRolePermissions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
